#pragma pack(2)
#ifndef AROS_MACHINE_H
#define AROS_MACHINE_H



#define AROS_STACK_GROWS_DOWNWARDS 1 
#define AROS_BIG_ENDIAN            1 
#define AROS_SIZEOFULONG           4 
#define AROS_WORDALIGN             2 
#define AROS_LONGALIGN             2 
#define AROS_PTRALIGN              2 
#define AROS_IPTRALIGN             2 
#define AROS_DOUBLEALIGN           2 
#define AROS_WORSTALIGN            8 


#define SP_OFFSET 0


struct JumpVec
{
    unsigned short jmp;
    unsigned char vec[4];
};


#define _aros_empty_vector		0xc0edbabe


#define __AROS_ASMJMP			0x4EF9
#define __AROS_SET_VEC(v,a)             (*(ULONG*)(v)->vec=(ULONG)(a))
#define __AROS_GET_VEC(v)               ((APTR)(*(ULONG*)(v)->vec))



#define __AROS_GETJUMPVEC(lib,n)        ((struct JumpVec *)(((UBYTE *)lib)-(n*LIB_VECTSIZE)))
#define __AROS_GETVECADDR(lib,n)        (__AROS_GET_VEC(__AROS_GETJUMPVEC(lib,n)))
#define __AROS_SETVECADDR(lib,n,addr)   (__AROS_SET_VEC(__AROS_GETJUMPVEC(lib,n),(APTR)(addr)))
#define __AROS_INITVEC(lib,n)           __AROS_SETVECADDR(lib,n,_aros_not_implemented)


#undef UseExecstubs
#define UseExecstubs 1


#define AROS_ALLOCENTRY_FAILED(memType) \
	((struct MemList *)((IPTR)(memType) | 0x80ul<<(sizeof(APTR)-1)*8))
#define AROS_CHECK_ALLOCENTRY(memList) \
	(!((IPTR)(memList) & 0x80ul<<(sizeof(APTR)-1)*8))


#define AROS_ALIGN(x)        (((x)+AROS_WORSTALIGN-1)&-AROS_WORSTALIGN)


extern void _aros_not_implemented (void);
extern void aros_not_implemented (void);


#define AROS_STACKSIZE	32768


#define RDFCALL(hook,data,dptr) ((void(*)(UBYTE __d0,APTR __a3))(hook))(data,dptr);


#define __AROS_LH_BASE(basetype,basename)   basetype basename = (basetype)REG_A6
#define __AROS_LP_BASE(basetype,basename)   basetype __base = basename
#define __AROS_LC_BASE(basetype,basename)   REG_A6 = (ULONG)__base
#define __AROS_LD_BASE(basetype,basename)   basetype __asm("r2")


#define __AROS_LHA(type,name,reg)     type name = (type) REG_##reg
#define __AROS_LPA(type,name,reg)     type r##reg = name
#define __AROS_LCA(type,name,reg)     REG_##reg = (ULONG)r##reg
#define __AROS_LDA(type,name,reg)     type
#define __AROS_UFHA(type,name,reg)    type name = (type) REG_##reg
#define __AROS_UFPA(type,name,reg)    type r##reg = name
#define __AROS_UFCA(type,name,reg)    REG_##reg = (ULONG)r##reg
#define __AROS_UFDA(type,name,reg)    type


#define __AROS_LH_PREFIX    
#define __AROS_LP_PREFIX    
#define __AROS_LC_PREFIX    
#define __AROS_LD_PREFIX    
#define __AROS_UFH_PREFIX   
#define __AROS_UFP_PREFIX   
#define __AROS_UFC_PREFIX   
#define __AROS_UFD_PREFIX   


#define __AROS_USE_MACROS_FOR_LIBCALL

#endif 



#pragma pack()
